#ifndef DEFS_SINGLETON_H
#define DEFS_SINGLETON_H

// my first singleton accessor
//maybe move it somewhere where everyone can use it?
//like defs.h?  or start breaking defs down?
template<typename T>
class Singleton {
protected:
	const char *initd;
	T *t;
	//TODO think up a way that won't break when sharing singletons between multiple static link libs
	//	I think the static local var inside validate() is instanciated once per static linked lib
	//	and therefore the init code will be called once per static linked lib
	void validate() {
		//local statics are the only thing i can think of that are init'd once, when they are first reached
		//(as opposed to global statics, etc, etc)
		//and persist from that point on
		//so I'll use that as my flag
		//...and i'll clear it on dtor, for the off chance a program is loaded twice in the exact same memory area
		static const char *verification = "verification";
		if (initd != verification) {
			initd = verification;
			//this request is being made and this condition met
			//long before the static initializer is giving the pointer its initial value...
			//...so when the static init'r does, it overwrites what we assign here...
			t = new T();
		}
	}
public:
	//ctor the object if it hasnt been already.  this way the dtor wont ever delete an invalid ptr
	Singleton() {
		validate();
	}
	virtual ~Singleton() {
		//this line will die if we haven't initialised the singleton by now ... 
		//so make sure the object is already ctored in the Singleton ctor
		delete t;	
		initd = 0;
		t = 0;
	}
	operator T*() {
		validate();
		return t;
	}
	T *operator->() {
		validate();
		return t;
	}
};

#endif	//DEFS_SINGLETON_H

